Subject: RFC 4678

From: Alfred Hönes <[email-masked]>
Date: Wed, 15 Nov 2006 22:00:32 +0100 (MEZ)

Hello,
after studying the recently published RFC 4678 (SASPv1)
authored by you, I would like to submit a few comments, pointing
out some issues I found with the RFC text, and supplying material
for an appropriate RFC Errata Note.

The items below are presented in RFC textual order.
I use change bars ('|' in column 1) and occasionally
up/down pointing marker lines ('^^^'/'vvv') to emphasize
the location of textual issues and/or proposed corrections.
Modified text has been re-adjusted to match RFC formatting
rules, where appropriate.

(1)  formatting

[ This note might just be of interest in deriving further work. ]

Most (but not all) "ruler lines" above message / data format diagrams
in RFC 4678 do not conform with the pattern in the RFC authoring guide.
The lines,

|     0                   1                   2                   3
       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      | ...                                                           |

should be indented as:

|      0                   1                   2                   3
       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      | ...                                                           |

(2)  unclear / misleading wording

On page 18, at the end of Section 7.1, RFC 4678 says:

                                                  [...].  Even though
   registrations can come from either the load balancer/scheduler or the
   actual member, member-initiated registrations will only be considered
|  if the Trust flag is set while the state of the load
|  balancer/scheduler is set.

The last two lines are far from being clear, or even misleading,
at first reading.
It becomes clear what perhaps was intended to say there as well
when arriving at Section 7.2 that says (at the bottom of page 20):

                                        ... will only be considered if
|  the Trust flag is set with a Set LB State message.

Perhaps, it would have been even better if both quotations would have
been changed to say (emphasizing the temporal relationship of events):

                                        ... will only be considered if
|  the Trust flag has been set with a Set LB State message.

(3)  incomplete specification

Section 7.3.2, in the first bullet on page 26,

   o  Interval: These two bytes indicate a recommended polling interval
      for the load balancer to use.  The Group Workload Manager is
      stating that any polling interval smaller than the suggested
      interval would probably retrieve values before they have had a
      chance to change.

does not mention the intended *unit* for this Interval -- seconds /
centiseconds / milliseconds ???

(4)  two significant typos

I strongly suspect that the type codes specified in Section 7.5.2
and Section 7.6.2 are wrong (duplicates from Section 7.2.2 ??)
Probably, Section 7.2, on page 6, gives the right values.

Therefore,
I propose to post an RFC Errata Note with the following content:

----  begin  RFC 4678 errata  ----

(a)
In Section 7.5.2, in the diagram on top of page 29, RFC 4678 says:

      [...]
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|     | Set Member State Reply(0x1025)|Size of SetMemberStateReply TLV|
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |  Return Code  |
      +-+-+-+-+-+-+-+-+

It should say:
                                   v
      [...]
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|     | Set Member State Reply(0x1065)|Size of SetMemberStateReply TLV|
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |  Return Code  |
      +-+-+-+-+-+-+-+-+

(b)
In Section 7.6.2, in the diagram on top of page 32, RFC 4678 says:

      [...]
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|     |   Set LB State Reply (0x1025) | Size of Set LB State Reply TLV|
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |  Return Code  |
      +-+-+-+-+-+-+-+-+

It should say:
                                  v
      [...]
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|     |   Set LB State Reply (0x1055) | Size of Set LB State Reply TLV|
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |  Return Code  |
      +-+-+-+-+-+-+-+-+

----  end    RFC 4678 errata  ----

Please comment.

All but item (1) seems to be appropriate for an Errata Note
-- I have set up a proposal for item (4), whereas items (2) and
(3) need your input;

Preferrably, you should submit an Author's Errata Note to the
RFC Editor's RFC Errata web pages, making freely use of the
material supplied above.  But if you like, I can formally
submit an Errata Note on my own, with your (input and) consent.

Best regards,
  Alfred Hönes.

-- 

+------------------------+--------------------------------------------+
| TR-Sys Alfred Hoenes   |  Alfred Hoenes   Dipl.-Math., Dipl.-Phys.  |
| Gerlinger Strasse 12   |  Phone: (+49)7156/9635-0, Fax: -18         |
| D-71254  Ditzingen     |  E-Mail:  [email-masked]                     |
+------------------------+--------------------------------------------+